vRPbm = {}
Tunnel.bindInterface("vRP_basic_menu",vRPbm)
vRPserver = Tunnel.getInterface("vRP","vRP_basic_menu")
HKserver = Tunnel.getInterface("vrp_hotkeys","vRP_basic_menu")
BMserver = Tunnel.getInterface("vRP_basic_menu","vRP_basic_menu")
vRP = Proxy.getInterface("vRP")

-------------car menu 
local enabled = false

RegisterCommand("vehiclemenu", function()
	if IsPedInAnyVehicle(PlayerPedId())  then
		EnableGUI(not enabled)
	end
end)
RegisterKeyMapping("vehiclemenu", "Meniu Vehicul", "KEYBOARD", "M")

local justOpen = false
local lastSettings = {}

function EnableGUI(enable)
	if not justOpen then
		enabled = enable

		justOpen = true
		Citizen.CreateThread(function()
			Wait(1000)
			justOpen = false
		end)

		SetNuiFocus(enable, enable)

		if enabled then
			lastSettings = {}
			SetNuiFocusKeepInput(true)

			Citizen.CreateThread(function()
				while enabled do
					refreshUI()
					Citizen.Wait(500)
				end
			end)

			Citizen.CreateThread(function()
				while enabled do
					DisableControlAction(0, 24, true) 
					DisableControlAction(0, 25, true) 
					DisableControlAction(0, 1, true)
					DisableControlAction(0, 2, true)
					DisableControlAction(0, 3, true)
					DisableControlAction(0, 4, true)
					DisableControlAction(0, 5, true)
					DisableControlAction(0, 6, true)
					DisableControlAction(0, 263, true)
					DisableControlAction(0, 264, true)
					DisableControlAction(0, 257, true)
					DisableControlAction(0, 140, true)
					DisableControlAction(0, 141, true)
					DisableControlAction(0, 142, true)
					DisableControlAction(0, 143, true)
					DisableControlAction(0, 177, true)
					DisableControlAction(0, 200, true)
					DisableControlAction(0, 202, true)
					DisableControlAction(0, 322, true)
					DisableControlAction(0, 245, true)
					Citizen.Wait(1)
				end
				SetNuiFocusKeepInput(false)
			end)
		end

		SendNUIMessage({
			type = "enablecarmenu",
			enable = enable
		})
	end
end

local function checkSeat(ped, veh, seatIndex)

	local driver = GetPedInVehicleSeat(veh, seatIndex)
	if driver == ped then
		return seatIndex
	elseif driver ~= 0 then
		return false
	else
		return true
	end
end

--[[ Check vehicles doors etc and send to UI --]]
function refreshUI()
	local settings = {}
	local ped = PlayerPedId()
	local veh = GetVehiclePedIsIn(ped)
	if veh ~= 0 then

		local model = GetEntityModel(veh)
		local seatsNum = GetVehicleModelNumberOfSeats(model)

		settings.seat1 = checkSeat(ped, veh, -1)
		settings.seat2 = checkSeat(ped, veh,  0)

		if seatsNum >= 3 then
			settings.seat3 = checkSeat(ped, veh,  1)
			settings.seat4 = checkSeat(ped, veh,  2)
		else
			settings.seat3 = false
			settings.seat4 = false
		end

		if settings.seat1 == -1 or settings.seat2 == 0 then
			settings.seat3 = false
			settings.seat4 = false
		elseif settings.seat3 == 1 or settings.seat4 == 2 then
			settings.seat1 = false
			settings.seat2 = false
		end

		settings.doorAccess = settings.seat1 == -1 and true or false
		if GetVehicleDoorAngleRatio(veh, 0) ~= 0 then
			settings.door0 = true
		end
		if GetVehicleDoorAngleRatio(veh, 1) ~= 0 then
			settings.door1 = true
		end

		if seatsNum >= 3 then
			if GetVehicleDoorAngleRatio(veh, 2) ~= 0 then
				settings.door2 = true
			end
			if GetVehicleDoorAngleRatio(veh, 3) ~= 0 then
				settings.door3 = true
			end
		else
			settings.door2 = -1
			settings.door3 = -1
		end
		
		if GetVehicleDoorAngleRatio(veh, 4) ~= 0 then
			settings.hood = true
		end
		if GetVehicleDoorAngleRatio(veh, 5) ~= 0 then
			settings.boot = true
		end

		if not IsVehicleWindowIntact(veh, 0) then
			settings.windowr1 = true
		end
		if not IsVehicleWindowIntact(veh, 1) then
			settings.windowl1 = true
		end
		if not IsVehicleWindowIntact(veh, 2) then
			settings.windowr2 = true
		end
		if not IsVehicleWindowIntact(veh, 3) then
			settings.windowl2 = true
		end

		local engine = GetIsVehicleEngineRunning(veh);
		--[[		
		local lockStatus = GetVehicleDoorLockStatus(veh)
		if (lockStatus == 1 or lockStatus == 0) and settings.seat1 == -1 then
		    settings.engineAccess = true
		end
		--]]
		if engine then
			settings.engine = true
		else
			settings.engine = false
		end

		SendNUIMessage({
			type = "refreshcarmenu",
			settings = settings
		})
	else
		EnableGUI(false)
	end
end

RegisterNUICallback('openDoor', function(data, cb)
	doorIndex = tonumber(data['doorIndex'])
	local ped = PlayerPedId()
	local veh = GetVehiclePedIsIn(ped, false)

	if veh ~= 0 then
		local lockStatus = GetVehicleDoorLockStatus(veh)
		if lockStatus == 1 or lockStatus == 0 then
			if (GetVehicleDoorAngleRatio(veh, doorIndex) == 0) then
				SetVehicleDoorOpen(veh, doorIndex, false, false)
			else
				ExecuteCommand("me Deschide/Inchide Usa")
				SetVehicleDoorShut(veh, doorIndex, false)
			end
		end
	end
	cb('ok')
end)

local justMooved = false

RegisterNUICallback('switchSeat', function(data, cb)
	if not justMooved then
		justMooved = true
		Citizen.CreateThread(function()
			Wait(1000)
			justMooved = false
		end)

		local seatIndex = tonumber(data['seatIndex'])
		local ped = PlayerPedId()
		local veh = GetVehiclePedIsIn(ped, false)
		if veh ~= 0 then
			local seatStatus = checkSeat(ped, veh, seatIndex)
			if seatStatus == true then
				ExecuteCommand("me Isi schimba locul")
				SetPedIntoVehicle(ped, veh, seatIndex)
				refreshUI()
			elseif seatStatus == false then
				exports["vrp_notify"]:MyVrpNotify('info', 'CarMenu', 'Loc ocupat', 1000)
			end
		end
		cb('ok')
	else
		exports["vrp_notify"]:MyVrpNotify('info', 'CarMenu', 'Asteapta', 1000)
	end
end)

RegisterNUICallback('togglewindow', function(data, cb)
	local windowIndex = tonumber(data['windowIndex'])
	local ped = PlayerPedId()
	local veh = GetVehiclePedIsIn(ped, false)

	if veh ~= 0 then
		 if not IsVehicleWindowIntact(veh, windowIndex) then
            RollUpWindow(veh, windowIndex)
			ExecuteCommand("me Deschide/Inchide Geam-ul")
            if not IsVehicleWindowIntact(veh, windowIndex) then
                RollDownWindow(veh, windowIndex)
            end
        else
            RollDownWindow(veh, windowIndex)
        end
        refreshUI()
	end
	cb('ok')
end)

RegisterNUICallback('toggleengine', function(data, cb)
	local ped = PlayerPedId()
	local veh = GetVehiclePedIsIn(ped, false)
	if veh ~= 0 then
		local engine = not GetIsVehicleEngineRunning(veh)

		if not IsPedInAnyHeli(ped) then
			ExecuteCommand("me Porneste/Opreste Motor-ul")
			SetVehicleEngineOn(veh, engine, false, true)
			SetVehicleJetEngineOn(veh, engine)
		else
			if engine then
				SetVehicleEngineOn(veh, true, false, true)
				if GetVehicleFuelLevel(veh) <= 2 then
					Citizen.Wait(600)
					SetVehicleEngineOn(veh, false, false, true)
				end
			else
				SetVehicleEngineOn(veh, false, false, true)
			end
		end
		refreshUI()
	end
	cb('ok')
end)

 RegisterNUICallback('escape', function(data, cb)
	EnableGUI(false)
	cb('ok')
end)
